<?php

namespace ADELANTE\PayBySquare\Observer;

use GuzzleHttp\Client;
use GuzzleHttp\Exception\GuzzleException;
use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;
use Magento\Sales\Model\Order;
use Magento\Sales\Model\OrderRepository;
use Psr\Log\LoggerInterface;
use ADELANTE\PayBySquare\Helper\Data;
use \ADELANTE\PayBySquare\Helper\CreateQRCode as CreateQrCodeHelper;

class CreateQRCode implements ObserverInterface
{

    /**
     * @var LoggerInterface
     */
    protected $logger;

    /**
     * @var Data
     */
    protected $data;

    /**
     * @var Client
     */
    protected $client;

    /**
     * @var OrderRepository
     */
    protected $orderRepository;

    /**
     * @var CreateQrCodeHelper
     */
    protected $createQRCode;

    /**
     * CreateQRCode constructor.
     *
     * @param LoggerInterface $loggerInterface
     * @param Data $data
     * @param Client $client
     * @param OrderRepository $orderRepository
     * @param CreateQrCodeHelper $createQRCode
     */
    public function __construct(
        LoggerInterface $loggerInterface,
        Data $data,
        Client $client,
        OrderRepository $orderRepository,
        CreateQrCodeHelper $createQRCode
    ) {
        $this->logger = $loggerInterface;
        $this->data = $data;
        $this->client = $client;
        $this->orderRepository = $orderRepository;
        $this->createQRCode = $createQRCode;
    }

    public function execute(Observer $observer)
    {
        /** @var Order $order */
        $order = $observer->getEvent()->getOrder();
        if (empty($order) || !$this->data->isEnableConfig() || !empty($order->getData('adelante_pay_by_square_code'))) return;
        $this->createQRCode->execute($order);
    }

}
